<?php
/*
Plugin Name: Rate Quote Widget
Plugin URI: http://ratequotewidget.com
Description: Lead qualification engine
Version: 1.3.1
Author: Dan Green
Author URI: http://ratequotewidget.com
*/

/*  
Copyright 2010 | RateQuoteWidget.com
Released under the GNU General Public License (GPL)
http://www.gnu.org/licenses/gpl.txt
*/


// Get settings
$btb_RQW_settings = btb_RQW_initialize_and_get_settings();

// Hook into WP
add_action('admin_menu', 'btb_RQW_options_page');
add_action("plugins_loaded", "btb_RQW_init");

/* WIDGET SETTINGS */
// Initialize the WP widget
function btb_RQW_init() {
  register_sidebar_widget(__('Rate Quote Widget'), 'widget_btb_RQW');    
}
// Show the WP Widget
function widget_btb_RQW() {
	$btb_RQW_url="http://ratequotewidget.com/rqw/rqwform.php"; // FORM SOURCE. DO NOT CHANGE
	//extract($args);	
	$btb_RQW_settings=array();
	$btb_RQW_settings = btb_RQW_initialize_and_get_settings();
	echo $before_widget;
  	echo $before_title . $after_title;
	$rqw_form="";
	$rqw_form=btb_RQW_get_the_form($btb_RQW_url, $btb_RQW_settings['rqw_apikey'], $btb_RQW_settings['rqw_width'],$btb_RQW_settings['rqw_css_override'], $btb_RQW_settings['rqw_show_link']);
	echo $rqw_form;
	echo $after_widget;
}

function btb_RQW_get_the_form($url, $rqw_apikey, $rqw_width, $rqw_css_override, $rqw_show_link) {
	$curl_output=array();
	$url_with_options="";
	$url_with_options=$url."?rqw_apikey=".$rqw_apikey."&rqw_width=".$rqw_width."&rqw_show_link=".$rqw_show_link;
	$curl_output=btb_RQW_getPage($url_with_options);
	return $curl_output['content']; 
}

/* PLUGIN SETTINGS */
// Initialize the WP options table
function btb_RQW_initialize_and_get_settings() {
	$options=array();
	// First, set the defaults
	$defaults = array(
		'rqw_title' => '',
		'rqw_apikey' => '',
		'rqw_width' => '350',
		'rqw_show_link' => 'on'
		);
	
	// Next, get current options and overwrite defaults
	if (get_option('btb_RQW_settings')) {
		$options=get_option('btb_RQW_settings');
		if ($defaults['rqw_title']!=$options['rqw_title']) {
			$defaults['rqw_title']=$options['rqw_title'];
		}
		if ($defaults['rqw_apikey']!=$options['rqw_apikey']) {
			$defaults['rqw_apikey']=$options['rqw_apikey'];
		}
		if ($defaults['rqw_width']!=$options['rqw_width']) {
			$defaults['rqw_width']=$options['rqw_width'];
		}		
		if ($defaults['rqw_css_override']!=$options['rqw_css_override']) {
			$defaults['rqw_css_override']=$options['rqw_css_override'];
		}		
		if ($defaults['rqw_show_link']!=$options['rqw_show_link']) {
			$defaults['rqw_show_link']=$options['rqw_show_link'];
		}
	}
	// Update the database
	update_option('btb_RQW_settings', $defaults, 'Options for Rate Quote Widget');
	return get_option('btb_RQW_settings');	
}
// Create a WP Plugins options page
function btb_RQW_options_page() {
	if (function_exists('add_options_page')) {
		add_options_page('Rate Quote Widget', 'Rate Quote Widget', 8, basename(__FILE__), 'btb_RQW_options_subpanel');
	}
}
// Create a form to process plugin options
function btb_RQW_options_subpanel() {
	global $btb_RQW_settings;
	
	if (isset($_POST['btb_RQW_save_settings'])) {
		check_admin_referer('btb_RQW_update_options');
		$btb_RQW_settings['rqw_apikey'] = stripslashes($_POST['rqw_apikey']);
		$btb_RQW_settings['rqw_width'] = stripslashes($_POST['rqw_width']);
		$btb_RQW_settings['rqw_css_override'] = stripslashes($_POST['rqw_css_override']);
		$btb_RQW_settings['rqw_show_link'] = stripslashes($_POST['rqw_show_link']);
		
		update_option('btb_RQW_settings', $btb_RQW_settings);
		$message='<div id="message" style="width:30%; padding:10px;" class="updated fade">Options Saved</div>';
	}
	?>
	<div class="wrap">
		<h2>Rate Quote Widget</h2>
		<?php echo isAPI($btb_RQW_settings['rqw_apikey']); ?>
		<?php echo $message; ?>

		<P>We built Rate Quote Widget to convert leads efficiently and effectively. Leveraging proven buyer psychology patterns and advanced lead generation techniques, Rate Quote Widget sorts through your inbound leads to find the most ready, willing and qualified customers. Fast.</p>
		
		<h3>Manually place the Rate Quote Widget</h3><P>Override your theme's widget settings. Place &lt;?php widget_btb_RQW(); ?&gt; in your theme where you want the form shown. Change widths below.<BR><BR></P>
		
		<h3>Widget Settings</h3>
		<form action="" method="post">
			<input type="hidden" name="btb_RQW_save_settings" value="true" />
			<table width="600">
			<tr valign="top">
				<th width="150" scope="row" align=right>Set Your API Key</th>
				<td width="450" align=left><input style="width:200px;" name="rqw_apikey" type="text" id="rqw_apikey" value="<?php echo attribute_escape($btb_RQW_settings['rqw_apikey']); ?>" /> &nbsp;&nbsp;Login to <a href=http://ratequotewidget.com target=_blank>lookup your API Key</a>.</td>
			</tr>
			<tr valign="top">
				<th width="150" scope="row" align=right>Set Widget Width</th>
				<td width="450">
					<select name="rqw_width" id="rqw_width">
					<option value="350"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="350"):?> SELECTED<?php endif;?>>350 pixels</option>
					<option value="345"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="345"):?> SELECTED<?php endif;?>>345 pixels</option>
					<option value="340"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="340"):?> SELECTED<?php endif;?>>340 pixels</option>
					<option value="335"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="335"):?> SELECTED<?php endif;?>>335 pixels</option>
					<option value="330"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="330"):?> SELECTED<?php endif;?>>330 pixels</option>
					<option value="325"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="325"):?> SELECTED<?php endif;?>>325 pixels</option>
					<option value="320"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="320"):?> SELECTED<?php endif;?>>320 pixels</option>
					<option value="315"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="315"):?> SELECTED<?php endif;?>>315 pixels</option>
					<option value="310"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="310"):?> SELECTED<?php endif;?>>310 pixels</option>
					<option value="305"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="305"):?> SELECTED<?php endif;?>>305 pixels</option>
					<option value="300"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="300"):?> SELECTED<?php endif;?>>300 pixels</option>
					<option value="295"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="295"):?> SELECTED<?php endif;?>>295 pixels</option>
					<option value="290"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="290"):?> SELECTED<?php endif;?>>290 pixels</option>
					<option value="285"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="285"):?> SELECTED<?php endif;?>>285 pixels</option>
					<option value="280"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="280"):?> SELECTED<?php endif;?>>280 pixels</option>
					<option value="275"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="275"):?> SELECTED<?php endif;?>>275 pixels</option>
					<option value="270"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="270"):?> SELECTED<?php endif;?>>270 pixels</option>
					<option value="265"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="265"):?> SELECTED<?php endif;?>>265 pixels</option>
					<option value="260"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="260"):?> SELECTED<?php endif;?>>260 pixels</option>
					<option value="255"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="255"):?> SELECTED<?php endif;?>>255 pixels</option>
					<option value="250"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="250"):?> SELECTED<?php endif;?>>250 pixels</option>
					<option value="245"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="245"):?> SELECTED<?php endif;?>>245 pixels</option>
					<option value="240"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="240"):?> SELECTED<?php endif;?>>240 pixels</option>
					<option value="235"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="235"):?> SELECTED<?php endif;?>>235 pixels</option>
					<option value="230"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="230"):?> SELECTED<?php endif;?>>230 pixels</option>
					<option value="225"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="225"):?> SELECTED<?php endif;?>>225 pixels</option>
					<option value="220"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="220"):?> SELECTED<?php endif;?>>220 pixels</option>
					<option value="215"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="215"):?> SELECTED<?php endif;?>>215 pixels</option>
					<option value="210"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="210"):?> SELECTED<?php endif;?>>210 pixels</option>
					<option value="205"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="205"):?> SELECTED<?php endif;?>>205 pixels</option>
					<option value="200"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="200"):?> SELECTED<?php endif;?>>200 pixels</option>
					<option value="195"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="195"):?> SELECTED<?php endif;?>>195 pixels</option>
					<option value="190"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="190"):?> SELECTED<?php endif;?>>190 pixels</option>
					<option value="185"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="185"):?> SELECTED<?php endif;?>>185 pixels</option>
					<option value="180"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="180"):?> SELECTED<?php endif;?>>180 pixels</option>
					<option value="175"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="175"):?> SELECTED<?php endif;?>>175 pixels</option>
					<option value="170"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="170"):?> SELECTED<?php endif;?>>170 pixels</option>
					<option value="165"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="165"):?> SELECTED<?php endif;?>>165 pixels</option>
					<option value="160"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="160"):?> SELECTED<?php endif;?>>160 pixels</option>
					<option value="155"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="155"):?> SELECTED<?php endif;?>>155 pixels</option>
					<option value="150"<?php if(attribute_escape($btb_RQW_settings['rqw_width'])=="150"):?> SELECTED<?php endif;?>>150 pixels</option>

					</select>
				</td>
			</tr>
			<tr valign="top">
				<th width="150" scope="row" align=right>Override CSS</th>
				<td width="450" align=left><textarea name="rqw_css_override" id="rqw_css_override" rows=5 READONLY>This is a placeholder for future release. No editing allowed. Yet. <?php echo attribute_escape($btb_RQW_settings['rqw_css_override']); ?></textarea></td>
			</tr>
			<tr valign="top">
				<th width="150" scope="row" align=right>Show Link To Author</th>
				<td width="450"><input name="rqw_show_link" type="checkbox" id="rqw_show_link" <?php if($btb_RQW_settings['rqw_show_link']=="on"):?> CHECKED<?php endif;?>/></td>
			</tr>
			<tr>
				<td width="150" scope="row" align=right>&nbsp;</td>
				<td width="450"><BR><input type="submit" name="submit" value="Save Settings" /></td>
			</table>

			<p></p>
			<?php
			if (function_exists('wp_nonce_field'))
				wp_nonce_field('btb_RQW_update_options');
			?>
		</form>
		<p>Rate Quote Widget is a <a href=http://bringtheblog.com/?r=rqw target=_blank>Bring the Blog</a> product. You may also like <a href=http://mortga.ge/charts Target=_blank>Real Estate Chart Of The Day</a>.</P>
		<p>Rate Quote Widget requires paid membership.</hp>
		
		</div>
		<div style="clear:both"></div>
		
		<P style="font-size:9px">&copy;Copyright <?php echo date("Y");?>, Bring the Blog, LLC.</p>

	</div>
	<?php
}

/* GET THE FORM CURL */
function btb_RQW_getPage($url){
    $options = array(
        CURLOPT_RETURNTRANSFER => true,     // return web page
        CURLOPT_HEADER         => false,    // don't return headers
        CURLOPT_FOLLOWLOCATION => true,     // follow redirects
        CURLOPT_ENCODING       => "",       // handle all encodings
        CURLOPT_USERAGENT      => "Rate Quote Widget", // who am i
        CURLOPT_CONNECTTIMEOUT => 30,      // timeout on connect
        CURLOPT_TIMEOUT        => 30,      // timeout on response
        CURLOPT_MAXREDIRS      => 2,       // stop after 10 redirects
    );
    $ch      = curl_init( $url );
    curl_setopt_array( $ch, $options );
    $content = curl_exec( $ch );
    $err     = curl_errno( $ch );
    $errmsg  = curl_error( $ch );
    $header  = curl_getinfo( $ch );
    curl_close( $ch );

    $header['errno']   = $err;
    $header['errmsg']  = $errmsg;
    $header['content'] = $content;
    return $header;
}
/* GET THE FORM CURL */
function isAPI($apikey){
	if ($apikey=="") {
		$btb_rqw_error_noapi='<div id="message" class="updated fade" style="width:60%; padding:10px; background-color: maroon; font-weight:bold;color:white;" >This plugin requires an API Key. Without one, the form will be hidden from your website.<BR>To get an API Key for the Rate Quote Widget, visit <a href="http://ratequotewidget.com/?apikey" target=_blank>http://ratequotewidget.com</a>.</div>';
		return $btb_rqw_error_noapi;
	}
}

?>